﻿Type=Class
Version=3
@EndOfDesignText@
'Events declaration
#Event: SingleClick

'Class module
Sub Class_Globals
   Private mTarget As Object
   Private mEventName As String

#Region  Constituent views 
	Private pnlBase As Panel
	Private btnAdd As Button
	Private btnOpen As Button
	Private aceItem As AutoCompleteEditText
	Private edtForFocus As EditText
#End Region

	Private mItems As List
	
	Private mDropForced As Boolean

End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
   mTarget = TargetModule
   mEventName = EventName
	
End Sub

Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	pnlBase = Base
	
	
'create the "Add" button and add it to the pnlBase panel.
	btnAdd.Initialize("btnAdd")
	ButtonSetStateListDrawable(btnAdd, "Plus.png", "plusPressed.png")

	Dim btnPlusSide, btnPlusTop As Int
	btnPlusSide = pnlBase.Width / 8
	btnPlusTop = (pnlBase.Height - btnPlusSide) / 2
	Dim btnPlusLeft As Int = pnlBase.Width - btnPlusSide - 1dip
	pnlBase.AddView(btnAdd, btnPlusLeft, btnPlusTop, btnPlusSide, btnPlusSide)


'create the "Open" button and add it to the pnlBase panel.
	btnOpen.Initialize("btnOpen")
	Dim btnOpenLeft As Int = btnPlusLeft - btnPlusSide - 1dip
	ButtonSetStateListDrawable(btnOpen, "triangolo.png", "triangoloPressed.png")
	pnlBase.AddView(btnOpen, btnOpenLeft, btnPlusTop, btnPlusSide, btnPlusSide)


'create the "Item" AutoCompleteEditText and add it to the pnlBase panel.
	aceItem.Initialize("aceItem")
	Dim aceItemLeft As Int = 2dip
	Dim aceItemWidth As Int = btnOpen.Left - 1dip - aceItemLeft - 2dip
	Dim aceItemHeight As Int = pnlBase.Height - 2dip
	Dim aceItemTop As Int = (pnlBase.Height - aceItemHeight + 2dip) / 2
	pnlBase.AddView(aceItem, aceItemLeft, aceItemTop, aceItemWidth, aceItemHeight)
	aceItem.TextColor = Colors.Black
	aceItem.TextSize = 15

' edtForFocus is used to "remove" the focus from aceItem
	edtForFocus.Initialize("")
	pnlBase.AddView(edtForFocus, pnlBase.Width + 1dip, 0, 10, 10)

End Sub

#Region  Views events 

Private Sub pnlBase_Touch (Action As Int, X As Float, Y As Float)
	Return True	
End Sub

Private Sub btnAdd_Click
'   'raise the event
'   CallSub(mTarget, mEventName & "_" & "SingleClick")

	Dim ind As InputDialog
	ind.InputType = ind.INPUT_TYPE_TEXT
	If ind.Show("message", "title", "OK", "Cancel", "", Null) = DialogResponse.POSITIVE Then
		If ind.Input.Length > 0 Then
			If Not(mItems.IsInitialized) Then
				mItems.Initialize
			End If
			mItems.Add(ind.Input)
			aceItem.setItems(mItems)
			aceItem.Text = ind.Input
			' Try to avoid the unwanted behavior:
			' ShowDropDown does not shows all the items, now.
			' Strangely, this command return "True" but the event does not fires!
			Log("focus " & edtForFocus.RequestFocus)
			DoEvents
			
		End If
	End If
	
End Sub

Private Sub btnOpen_Click ' TODO evento apertura spinner
	If mDropForced Then
		aceItem.DismissDropDown
	Else
		aceItem.ShowDropDown
	End If
	mDropForced = Not(mDropForced)
End Sub

Private Sub aceItem_ItemClick (Value As String)
	
End Sub

Private Sub edtForFocus_FocusChanged (HasFocus As Boolean)
	Log("HasFocus = " & HasFocus)
End Sub

#End Region

Public Sub setItems(Items As List)
	mItems = Items
	aceItem.setItems(mItems)
End Sub

Private Sub ButtonSetStateListDrawable(btnBitmap As Button, EnabledImageFileName As String, PressedImageFileName As String)
	' Define a bitmap for Enabled state
	Dim bdwEnabled As BitmapDrawable
	bdwEnabled.Initialize(LoadBitmap(File.DirAssets, EnabledImageFileName))
	' Define a bitmap for Pressed state
	Dim bdwPressed As BitmapDrawable
	bdwPressed.Initialize(LoadBitmap(File.DirAssets, PressedImageFileName))
	' Define a StateListDrawable
	Dim stdBitmap As StateListDrawable
	stdBitmap.Initialize
	Dim states(2) As Int
	states(0) = stdBitmap.state_enabled
	states(1) = -stdBitmap.state_pressed
	stdBitmap.addState2(states, bdwEnabled)
	Dim states(1) As Int
	states(0) = stdBitmap.state_enabled
	stdBitmap.addState2(states, bdwPressed)
	' Set stdBitmap to button btnBitmap
	btnBitmap.Background = stdBitmap
End Sub